program mat_ascii2bin
!-----------------------------------------------------------------------------------------
! Programma per leggere una matrice in formato coordinate e stamparla in binario
!-----------------------------------------------------------------------------------------

use class_precision

implicit none

integer                        :: nn,nt
integer, allocatable           :: irow(:),ja(:)
real(kind=double), allocatable :: coef(:)

integer                        :: i,j,alinfo
real(kind=double)              :: T_read,T_write
real(kind=double)              :: omp_get_wtime

character*100                  :: file_in,file_out

! Lettura dei nomi dei file
read(*,*) file_in
read(*,*) file_out

! Lettura delle dimensioni
open(1,file=file_in)
read(1,*) nn,nt
! Allocazione generale
allocate(irow(nt),ja(nt),coef(nt),stat=alinfo)
if (alinfo .ne. 0) then
   open(100,file='ERRS')
   write(100,*) 'Errore di allocazione'
   close(100)
   stop
endif

! Lettura della matrice in formato ASCII
T_read = omp_get_wtime()
do i = 1,nt
   read(1,*) irow(i),ja(i),coef(i)
enddo
T_read = omp_get_wtime() - T_read
close(1)

! Scrittura della matrice in formato binario
T_write = omp_get_wtime()
open(2,file=file_out,form='unformatted',access='stream')
write(2) nn,nt
write(2) (irow(i),ja(i),coef(i),i=1,nt)
close(2)
T_write = omp_get_wtime() - T_write

! Stampa dei tempi
open(200,file='Times_A2B')
write(200,'(a,f10.2)') 'Tempo di lettura:  ',T_read
write(200,'(a,f10.2)') 'Tempo di scrittura:',T_write
close(200)

! Deallocazione generale
deallocate(irow,ja,coef,stat=alinfo)
if (alinfo .ne. 0) then
   open(100,file='ERRS')
   write(100,*) 'Errore di deallocazione'
   close(100)
   stop
endif

end program mat_ascii2bin
